#!/bin/ksh
#

########################################################
# set paths and files

MODULE="LuUTRAN"
RELEASE="6.0.9.2.0"    
RP=$(echo $RELEASE|sed 's/\.//g')

SourceDir="${FLEXPM_HOME}/patches/${RELEASE}"
WorkDir=$SourceDir/workdir
TarDir=${SourceDir}/tarball/${MODULE}_${RP}_UI.tgz

### stamping ts
s_yyyymmdd=`(date "+%Y%m%d")`
s_hhmmss=`(date "+%H%M%S")`
mkdir -p $SourceDir/Backup
echo "$s_yyyymmdd.$s_hhmmss" > $SourceDir/Backup/.ts.txt

### get ts
TS=`cat $SourceDir/Backup/.ts.txt`
BACKUP_DIR=$SourceDir/Backup/$TS

########################################################

# Check env settings
 echo "Checking environment....."

  if ! [[ -d ${FLEXPM_HOME} ]]; then
     echo "Env variable FLEXPM_HOME must be set to appropriate dir before installation."
     exit;
  fi

  if ! [[ -d ${FLEXPM_BASE} ]]; then
     echo "Env variable FLEXPM_BASE must be set to appropriate dir before installation."
     exit;
  fi

  if [ -z ${DB_CONNECT} ]; then
     echo "Env variable DB_CONNECT must be set to appropriate database connection values."
     exit 1;
  fi

  ###### module variable validation
  if ! [[ -d ${LuUTRAN_HOME} ]]; then
     echo "Env variable LuUTRAN_HOME must be set to appropriate dir before installation."
     exit;
  fi

    #######################################################
    # Installing module...
    #######################################################

    date +"+ Installing Patch $MODULE $RELEASE at %T, %D ..."

    echo "+ Backing up original files and installing new files..."
    cd $FLEXPM_BASE
    mkdir -p ${BACKUP_DIR}

    ${WorkDir}/untar.pl $SourceDir $TarDir $FLEXPM_BASE $BACKUP_DIR
    ret=$?

    if [ $ret != 0 ]; then
      echo "+++ Error in untar.pl"
      exit 2
    fi


    ###### module installation customization here...

    date +"+ $MODULE $RELEASE upgrade is completed at %T, %D"
    echo ""

