###########################################################################
#
# Licensed Materials - Property of IBM
# 5724-T05
#
# (C) Copyright IBM Corp. 2003,2009. All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
###########################################################################

export DBUSER_UC=`echo $DBUSER |tr "[a-z]" "[A-Z]"`

sqlplus -s ${DB_CONNECT} <<!

BEGIN
  FOR cur_rec IN (SELECT owner,
                         object_name,
                         object_type
                  FROM   dba_objects
                  WHERE  object_type = 'VIEW'
                  AND    status != 'VALID'
				  AND 	 owner = '${DBUSER_UC}' )

  LOOP
    BEGIN
        EXECUTE IMMEDIATE 'ALTER VIEW "' || cur_rec.owner || 
            '"."' || cur_rec.object_name || '" COMPILE';

    EXCEPTION
      WHEN OTHERS THEN
        DBMS_OUTPUT.put_line(cur_rec.object_type || ' : ' || cur_rec.owner || 
                             ' : ' || cur_rec.object_name);
    END;
  END LOOP;
END;
/
exit;
!
