---------------------------------------------------------------------------
--
-- Licensed Materials - Property of IBM
-- 5724-T05
--
-- (C) Copyright IBM Corp. 2003,2009. All Rights Reserved.
--
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
---------------------------------------------------------------------------

SET SERVEROUTPUT ON SIZE 1000000

-- --------------------------------------------------------------------
-- --------------------------------------------------------------------
DECLARE
        CURSOR cFileTypes IS
           SELECT wfile.file_type_id, dict.table_id
             FROM WM_FILE_CONTROL wfile, WMD_DICT_TABLE dict
            WHERE dict.table_name='WMN_INSTANCE' OR dict.table_name='GEN_ENT_NE_SYSTEM';

BEGIN
        INSERT INTO WMD_TABLE_GROUP
           (table_id, table_base_name, entity_id, frequency_id)
           SELECT x.table_id, 'WMN_INSTANCE', x.entity_id, NULL
             FROM
             (SELECT dict.table_id, ent.entity_id
                FROM WMD_DICT_TABLE dict, WMN_ENTITY ent
               WHERE dict.table_name='WMN_INSTANCE'
                 AND dict.entity_id = ent.entity_id ) x
               WHERE NOT EXISTS
                     (SELECT table_id
                        FROM WMD_TABLE_GROUP
                       WHERE WMD_TABLE_GROUP.table_id = x.table_id );

        INSERT INTO WMD_TABLE_GROUP
           (table_id, table_base_name, entity_id, frequency_id)
           SELECT x.table_id, 'GEN_ENT_NE_SYSTEM', x.entity_id, NULL
             FROM
             (SELECT dict.table_id, ent.entity_id
                FROM WMD_DICT_TABLE dict, WMN_ENTITY ent
               WHERE dict.table_name='GEN_ENT_NE_SYSTEM'
                 AND dict.entity_id = ent.entity_id ) x
               WHERE NOT EXISTS
                     (SELECT table_id
                        FROM WMD_TABLE_GROUP
                       WHERE WMD_TABLE_GROUP.table_id = x.table_id );


        FOR vFileType IN cFileTypes LOOP
           BEGIN
              INSERT INTO WM_FILE_TABLE_MAP
                (file_type_id, table_id)
              VALUES (vFileType.file_type_id, vFileType.table_id);
           EXCEPTION
              WHEN DUP_VAL_ON_INDEX THEN
                 DBMS_OUTPUT.PUT_LINE('  -- OK (Exists)');
           END;
        END LOOP;

END;
/

COMMIT;
show errors;
EXIT;
